
// Demo-Programm: Verwendung von Funktionszeigern

#include <iostream.h>

int func1 (double, int, char *);
    // Deklaration (Prototyp) einer Funktion, die drei Parameter vom Typ
    // double, int, und Zeiger auf char bernimmt und ein Resultat vom
    // Typ int zurckgibt

int func2 (double, int, char *);        // detto
int func3 (double, int, char *);        // detto

int (*funcptr) (double, int, char *) = func1;
    // Zeiger namens "funcptr", der auf eine Funktion weist, die drei
    // Parameter vom Typ double, int, und Zeiger auf char bernimmt und
    // ein int-Resultat hat

int (*fparray[]) (double, int, char *) =
{
    func1,
    func2,
    func3
};
    // Feld namens "fparray" von drei Funktions-Zeigern wie oben

int libfunc (int, int (*)(double, int, char*));
    // Prototyp einer Bibliotheksfunktion "libfunc", die als zweiten
    // Parameter einen Zeiger auf eine Funktion hat, wie sie oben
    // definiert wurde

int main ()
{
    double Wert = 3.14;
    int Schalter = 12;
    char *Meldg = "Hello, world!";
    int i;

    // Funktion func1 ber Funktions-Zeiger ausfhren:

    i = funcptr (Wert, Schalter, Meldg);

    // quivalent zu:

    i = func1 (Wert, Schalter, Meldg);

    // alternative Syntax:

    i = (*funcptr)(Wert, Schalter, Meldg);

    // Funktions-Zeiger als Parameter bergeben:

    i = libfunc (4711, funcptr);

    // Funktion aus Feld der Funktions-Zeiger auswhlen und ausfhren:

    for (int j = 0; j < 3; j++)
        i = fparray [j] (12.34, 3, "Das ist ein Test");

    // ist speziell bei vielen Funktionen viel effizienter als
    // Programmverzweigungen
}

int func1 (double Wert, int Schalter, char *Meldung)
{
    cout << "Das ist Funktion func1: Wert = " << Wert << ", Schalter = "
        << Schalter << ", Meldung = " << Meldung << "\n";

    return 1;
}

int func2 (double Wert, int Schalter, char *Meldung)
{
    cout << "Das ist Funktion func2: Wert = " << Wert << ", Schalter = "
        << Schalter << ", Meldung = " << Meldung << "\n";

    return 2;
}

int func3 (double Wert, int Schalter, char *Meldung)
{
    cout << "Das ist Funktion func3: Wert = " << Wert << ", Schalter = "
        << Schalter << ", Meldung = " << Meldung << "\n";

    return 3;
}

int libfunc (int nPar1, int (*fpUser) (double, int, char*))
{
    return fpUser (6.28, nPar1, "Error");
}
