
// Demo-Programm: Statische Klassenelemente und Klassenelement-Funktionen
//                Konstruktion und Destruktion von Klassen-Objekten
//                Lebensdauer von Objekten mit automatischer
//                Speicherklasse

#include <iostream.h>

class Punkt
{
public:
    Punkt ()                    // Konstruktor
        { PunkteZahl++; }
    ~Punkt ()                   // Destruktor
        { PunkteZahl--; }

    unsigned& x()               // Zugriffsfunktion
        { return xKoord; }
    unsigned& y()               // Zugriffsfunktion
        { return yKoord; }

    static int Anzahl()         // statische Zugriffsfunktion
        { return PunkteZahl; }

    static int PunkteZahl;      // statisches Klassenelement

private:
    unsigned xKoord;
    unsigned yKoord;
};

// Definition von Punkt::PunkteZahl:
int Punkt::PunkteZahl = 0;


int main ()
{
    cout << "Anzahl der Punkte: " << Punkt::Anzahl () << "\n";
        // "Punkt::Anzahl", weil statische Funktion

    Punkt p1;                   // neues Objekt
    cout << "Anzahl der Punkte: " << Punkt::Anzahl () << "\n";
    {
        Punkt p2;
        cout << "Anzahl der Punkte: " << Punkt::Anzahl () << "\n";
        {
            Punkt p3;
            cout << "Anzahl der Punkte: " << Punkt::Anzahl () << "\n";

            // Koordinaten zuweisen - Zugriffsfunktion verwendet
            // Referenzen fr ihr Ergebnis!

            p1.x() = 20;
            p1.y() = 30;
        }

        // Punkt p3 existiert nicht mehr
        cout << "Anzahl der Punkte: " << Punkt::Anzahl () << "\n";
    }

    // Punkt p2 existiert nicht mehr
    cout << "Anzahl der Punkte: " << Punkt::Anzahl () << "\n";

    // Koordinaten von Punkt p1 ausgeben
    cout << p1.x() << ", " << p1.y() << "\n";
}
