
// Demo-Programm: Explizite Typumwandlung eines Zeigers
//                Verbesserte Version des Prfsummen-Programms

#include <stdio.h>      // ANSI-C-Ein-Ausgabe-Funktionen
#include <string.h>     // String-Manipulations-Funktionen

unsigned short checksum (char *buffer, unsigned int size);
    // Prototyp der Prfsummen-Funktion

int main ()
{
    printf ("String (max. 127 Zeichen): ");     // Konsol-Ausgabe

    char buffer[128];

    gets (buffer);
        // Eingabe eines beliebigen Strings

    unsigned short i = checksum (buffer, strlen (buffer) + 1);
        // checksum rundet ungeradzahlige size-Argumente immer nach
        // unten; damit wird das letzte Zeichen nicht mehr in der
        // Prfsumme erfat.
        // "strlen (buffer) + 1" bewirkt, da das abschlieende Null-Byte
        // in die Prfsumme mit einbezogen wird.
        // Mit dieser nderung ergibt sich folgendes Verhalten:
        // strlen (buffer) gerade:      Die Prfsumme umfat den String
        //                              OHNE Null-Byte.
        // strlen (buffer) ungerade:    Die Prfsumme umfat den String
        //                              UND das Null-Byte.

    printf ("Prfsumme = 0x%04x\n", i);
        // formatierte Ausgabe
}

unsigned short checksum (char *buffer, unsigned int size)
{
    unsigned short sum = 0;                // Prfsumme
    unsigned int i = size / sizeof(short); // Anzahl der shorts in buffer

    // kompaktere Schreibweise der Schleife

    while (i--)
        sum += *((unsigned short *) buffer)++;

    return sum;
}
