
// Demo-Programm: "for"-Schleifen + "break"
//                Sortieren mit verbesserter Version von HoleZahlen

#define FELDGROESSE 20
#include <iostream.h>

int HoleZahlen (int *Feld, int Groesse);
void Schreibe (int *Feld, int Aktiv);
void Sortiere (int *Feld, int Aktiv);


int main ()
{
    int IntFeld [FELDGROESSE];

    int AktGroesse = HoleZahlen (IntFeld, 
        sizeof IntFeld/sizeof IntFeld[0]);

    Schreibe (IntFeld, AktGroesse);

    Sortiere (IntFeld, AktGroesse);

    Schreibe (IntFeld, AktGroesse);
}


// maximal <Groesse> ints einlesen und in <Feld> abspeichern;
// tatschliche Zahl der ints zurckgeben:

int HoleZahlen (int *Feld, int Groesse)
{
    for (int Zaehler = 0; Zaehler < Groesse; Zaehler++)
    {
        int temp;

        cout << "Zahl: ";
        cin >> temp;

        if (! temp)                 // == 0
            break;

        *(Feld + Zaehler) = temp;
    }

    return Zaehler;
}
 

// Inhalt von <Feld>, getrennt durch Kommas, ausschreiben:

void Schreibe (int *Feld, int Aktiv)
{
    for (int i = 0; i < Aktiv; i++)
        cout << Feld[i] << ((i < Aktiv - 1) ? ", " : "\n");
}


// <Aktiv> Elemente von <Feld> in aufsteigender Reihenfolge sortieren:

void Sortiere (int *Feld, int Aktiv)
{
    for (int i = 0; i < Aktiv - 1; i++)
    {
        for (int j = i + 1; j < Aktiv; j++)
        {
            if (Feld[i] > Feld[j])
            {
                // Feldelemente vertauschen

                int temp = Feld[i];
                Feld[i] = Feld[j];
                Feld[j] = temp;
            }
        }
    }
}
