
// Demo-Programm: Statische Klassenelemente und Klassenelement-Funktionen

#include <iostream.h>

class Punkt
{
public:
    Punkt ()                            // Konstruktor
        { PunkteZahl++; }
    ~Punkt ()                           // Destruktor
        { PunkteZahl--; }

    unsigned& x()                       // Zugriffsfunktionen
        { return xKoord; }
    unsigned& y()
        { return yKoord; }

    static int Anzahl()                 // statische Zugriffsfunktion
        { return PunkteZahl; }

    static int PunkteZahl;              // statisches Klassenelement

private:
    unsigned xKoord;
    unsigned yKoord;
};

// Definition des statischen Klassenelements Punkt::PunkteZahl:
int Punkt::PunkteZahl = 0;

int main ()
{
    cout << "Anzahl der Punkte: " << Punkt::Anzahl () << "\n";
        // "Punkt::Anzahl()", weil statische Funktion

    Punkt p1;                           // neues Objekt
    cout << "Anzahl der Punkte: " << p1.Anzahl () << "\n";
        // p1 ist ein gltiges Objekt; Anzahl() kann auch ber jedes
        // Objekt der Klasse aufgerufen werden
    {
        Punkt p2;
        cout << "Anzahl der Punkte: " << p1.Anzahl () << "\n";
        {
            Punkt p3;
            cout << "Anzahl der Punkte: " << p3.Anzahl () << "\n";

            // Koordinaten zuweisen - Zugriffsfunktion verwendet
            // Referenzen fr ihr Ergebnis!

            p1.x() = 20;
            p1.y() = 30;
        }

        // Punkt p3 existiert nicht mehr
        cout << "Anzahl der Punkte: " << p2.Anzahl () << "\n";
    }

    // Punkt p2 existiert nicht mehr
    cout << "Anzahl der Punkte: " << Punkt::Anzahl () << "\n";

    // Koordinaten von Punkt p1 ausgeben
    cout << p1.x() << ", " << p1.y() << "\n";
}
