
// Demo-Programm: Unions; Overloaded Konstruktoren; Aufzhlungstypen
//                Variante: Anonyme Union

#include <iostream.h>

class Data
{
    enum DataType { Char, Int, String };

    DataType type;              // ist private!

    union
    {
        char CharData;
        int IntData;
        char *StringData;
    };

    _data (int i)               // Hilfsfunktion
    {
        IntData = i;
        type = Int;
    }

public:
    Data ()                     // Default-Konstruktor
        { _data (0); }

    Data (int i)                // Konstruktor fr int-Datenelement
         { _data (i); }

    Data (char ch)              // Konstruktor fr char-Datenelement
    { 
        CharData = ch;
        type = Char;
    }

    Data (char *psz)            // Konstruktor fr String-Datenelement
    {
        StringData = psz;
        type = String;
    }

    void Print ();              // Ausgabe-Funktion; hier nur deklariert
};
 
void Data::Print (void)         // Definition der Ausgabe-Funktion
{
    switch (type)
    {
        case Char:
            cout << "char:   " << CharData << "\n";
            break;

        case Int:
            cout << "int:    " << IntData << "\n";
            break;

        case String:
            cout << "string: " << StringData << "\n";
            break;
    }
}

int main ()
{
    Data d1;                            // Default: int = 0
    Data d2 = 'K';                      // type = Char
    Data d3 = 17;                       // type = Int
    Data d4 = "Hello, world!";          // String

    d1.Print();
    d2.Print();
    d3.Print();
    d4.Print();

    d2.CharData = 'L';          // direkter Zugriff auf Element der union
    d2.Print();
}
