
// Demo-Programm: Unions; Overloaded Konstruktoren; Aufzhlungstypen
//                Variante: Benannte Union

#include <iostream.h>

class Data
{
    enum DataType { Char, Int, String };

    DataType type;              // ist private!

    union
    {
        char CharData;
        int IntData;
        char *StringData;
    } DataUnion;                // benannte Union

    _data (int i)               // Hilfsfunktion
    {
        DataUnion.IntData = i;
        type = Int;
    }

public:
    Data ()                     // Default-Konstruktor
        { _data (0); }

    Data (int i)                // Konstruktor fr int-Datenelement
        { _data (i); }

    Data (char ch)              // Konstruktor fr char-Datenelement
    { 
        DataUnion.CharData = ch;
        type = Char;
    }

    Data (char *psz)            // Konstruktor fr String-Datenelement
    {
        DataUnion.StringData = psz;
        type = String;
    }
        
    void Print ();              // Ausgabe-Funktion: hier nur deklariert
};

void Data::Print (void)         // Definition der Ausgabe-Funktion
{
    switch (type)
    {
        case Char:
            cout << "char:   " << DataUnion.CharData << "\n";
            break;

        case Int:
            cout << "int:    " << DataUnion.IntData << "\n";
            break;

        case String:
            cout << "string: " << DataUnion.StringData << "\n";
            break;
    }
}

int main ()
{
    Data d1;                            // Default: int = 0
    Data d2 = 'K';                      // type = Char
    Data d3 = 17;                       // type = Int
    Data d4 = "Hello, world!";          // String

    d1.Print();
    d2.Print();
    d3.Print();
    d4.Print();

    // Ein direkter Zugriff auf ein Element der Union, etwa mit
    // "d2.DataUnion.CharData = 'L';" ist nicht mglich, weil das
    // Element DataUnion als private deklariert wurde. (Die anonyme
    // Union im Parallel-Demo-Programm, die an der gleichen Stelle
    // deklariert wurde, ist als anonymes Klasse auf jeden Fall
    // public.)
}
