
// Demo-Programm: Einfache Vererbung - Virtuelle Funktionen und
//                abstrakte Klassen:
//                "Bibliotheksverwaltung"

#include <iostream.h>
#include <string.h>
#include <ctype.h>

// Basisklasse fr alle anderen Klassen
class Dokument
{
public:
    char *Name;          // Name des Dokuments

    Dokument () { }      // Default-Konstruktor
    Dokument (char *name)       // Konstruktor fr char*
        { Speichern (name); }

    virtual void PrintName () = 0;
        // reine virtuelle Ausgabe-Funktion
 
    void Speichern (char *name) // Hilfsfunktion
    {
        Name = new char [strlen (name) + 1];
        strcpy (Name, name);
    }
};

class Druckwerk : public Dokument
{
public:
    Druckwerk () { }
    Druckwerk (char *name)
        { Speichern (name); }
};

class Datei : public Dokument
{
public:
    Datei () { }
    Datei (char *name)
        { Speichern (name); }

    virtual void PrintName ()
        { cout << "Datei: " << Name << "\n"; }
};

class Buch : public Druckwerk
{
public:
    Buch () { }
    Buch (char *name)
        { Speichern (name); }

    virtual void PrintName ()
        { cout << "Buchtitel: "<< Name << "\n"; }
};

class Zeitschrift : public Druckwerk
{
public:
    Zeitschrift () { }
    Zeitschrift (char *name)
        { Speichern (name); }

    virtual void PrintName ()
        { cout << "Zeitschrift: " << Name << "\n"; }
};

class Taschenbuch : public Buch
{
public:
    Taschenbuch () { }
    Taschenbuch (char *name)
        { Speichern (name); }
};

class Hilfsdatei : public Datei
{
public:
    Hilfsdatei () { }
    Hilfsdatei (char *name)
        { Speichern (name); }
};

class Tutorial : public Datei
{
public:
    Tutorial () { }
    Tutorial (char *name)
        { Speichern (name); }
};

const int BibGroesse = 10;      // Anzahl der Eintrge

int main ()
{
    Dokument *Bibliothek [BibGroesse];
        // "Datenbank"

    cout << "Typ der Eintragung:\n"
    //  "(D)okument, D(r)uckwerk," stehen nicht mehr zur Verfgung
        "D(a)tei, (B)uch, (Z)eitschrift, (T)aschenbuch, (H)ilfsdatei, "
        "T(u)torial:\n\n";

    // lies BibGroesse Eintragungen fr die "Bibliothek"

    for (int i = 0; i < BibGroesse; i++)
    {
        char cDtyp;             // Schalt-Zeichen
        char buffer [128];

        cout << "Typ:   ";
        cin.getline (buffer, 128, '\n');
        cDtyp = *buffer;

        cout << "Titel: ";
        cin.getline (buffer, 128, '\n');

        // konvertiere cDtyp in Kleinbuchstaben

        switch (tolower (cDtyp))
        {
            // trage jede Eintragung mit dem korrekten Konstruktor ein

            /***********************************************************

                Die folgenden Befehle sind unzulssig, weil fr Dokument
                und Druckwerk keine PrintName()-Funktion existiert:

            case 'd':
                Bibliothek[i] = new Dokument (buffer);
                break;

            case 'r':
                Bibliothek[i] = new Druckwerk (buffer);
                break;

           ************************************************************/

            case 'a':
                Bibliothek[i] = new Datei (buffer);
                break;

            case 'b':
                Bibliothek[i] = new Buch (buffer);
                break;

            case 'z':
                Bibliothek[i] = new Zeitschrift (buffer);
                break;

            case 't':
                Bibliothek[i] = new Taschenbuch (buffer);
                break;

            case 'h':
                Bibliothek[i] = new Hilfsdatei (buffer);
                break;

            case 'u':
                Bibliothek[i] = new Tutorial (buffer);
                break;

            default:
                i--;    // Kompensation von "i++"
        }
    }

    // gib alle Eintragungen aus

    for (i = 0; i < BibGroesse; i++)
        Bibliothek[i]->PrintName();
}
