
// Demo-Programm: friend-Funktionen und overloaded Operator

#include <iostream.h>

class Punkt
{
public:
    Punkt (short x, short y)
        { _x = x; _y = y; }
    void Print()
        { cout << "Punkt (" << _x << ", " << _y << ")\n"; }

private:
    short _x, _y;

    // friend-Deklarationen

    friend Punkt operator+(Punkt&, int); 
    friend Punkt operator+(int, Punkt&);
};


// Definition der friend-Funktionen

// Operation "Punkt + Offset"

Punkt operator+(Punkt& pt, int offset) 
{
    Punkt temp = pt;

    // direkter Zugriff auf private Elemente

    temp._x += offset;
    temp._y += offset;

    return temp;
}

// Operation "Offset + Punkt"

Punkt operator+(int offset, Punkt& pt) 
{
    Punkt temp = pt;

    // direkter Zugriff auf private Elemente

    temp._x += offset;
    temp._y += offset;

    return temp;
}


int main ()
{
    Punkt p(10, 20);
    p.Print();

    p = p + 5;          // ruft 1. operator+ auf
    p.Print();

    p = 3 + p;          // ruft 2. operator+ auf
    p.Print();
}
