
// Demo-Programm: Funktions- und Klassen-Schablonen

#include <iostream.h>

template <class Type> class Feld
{
public:
    Feld (int groesse = 1)              // Konstruktor
    {
        f = new Type [gr = groesse];
    }

    ~Feld ()                            // Destruktor
    {
        delete[] f;
    }

    int gr;     // Datenelement: Gre
    Type *f;    // Zeiger auf Feldelemente
};

// generalisierte Sortierfunktion
// Definition:

template <class T> void sort (Feld<T>& F)
{
    unsigned n = F.gr;  // Feldgre

    for (int i = 0; i < n - 1; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            if (F.f[i] > F.f[j])
            {
                T temp = F.f[i];
                F.f[i] = F.f[j];
                F.f[j] = temp;
            }
        }
    }
}

// Prototyp:

template <class T> void sort (Feld<T>&);

// spezielle Ausgabefunktion
// Prototyp:

void show (int, Feld<char>&, Feld<int>&, Feld<double>&);

// Definition:
void show (int zahl, Feld<char>& Fc, Feld<int>& Fi, Feld<double>& Fd)
{
    for (int i = 0; i < zahl; i++)
        cout << Fc.f[i] << "\t" << Fi.f[i] << "\t" << Fd.f[i] << "\n";
}

int main ()
{
    int zahl;

    cout << "Feldgre:       ";
    cin >> zahl;

    // "Felder" definieren:

    Feld <char> Fc (zahl);              // chars
    Feld <int> Fi (zahl);               // ints
    Feld <double> Fd (zahl);            // doubles

    for (int i = 0; i < zahl; i++)
    {
        cout << "Zeichen:         ";
        cin >> Fc.f[i];
        cout << "Ganze Zahl:      ";
        cin >> Fi.f[i];
        cout << "Gleitkommazahl:  ";
        cin >> Fd.f[i];
    }

    cout << "\nUnsortiert:\n";

    show (zahl, Fc, Fi, Fd);

    // sortieren

    sort (Fc);
    sort (Fi);
    sort (Fd);

    cout << "\nSortiert:\n";

    show (zahl, Fc, Fi, Fd);
}
