
// Demo-Programm: Funktions- und Klassen-Schablonen - verbesserte Version

#include <iostream.h>
#include <string.h>

// generalisierte Klasse "Vergleich"

template <class T> class Vergleich
{
public:
    static int groesser (T& a, T& b)
    {
        return a > b;
    }
};

// spezielle Klasse fr char*

class Vergleich <char*>
{
public:
    static int groesser (char *a, char *b)
    {
        return strcmp (a, b) > 0;
    }
};

// Definition der Klasse Feld:

template <class Type> class Feld
{
public:
    Feld (int groesse = 1)              // Konstruktor
        { f = new Type [gr = groesse]; }

    ~Feld ()                            // Destruktor
        { delete[] f;   }

    int gr;                             // Datenelement: Gre
    Type *f;                            // Zeiger auf Feldelemente
};

// Sortierfunktion:

template <class T> void sort (Feld<T>& F)
{
    unsigned n = F.gr;                  // Feldgre

    for (int i = 0; i < n - 1; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            if (Vergleich<T>::groesser(F.f[i], F.f[j]))
            {
                T temp = F.f[i];
                F.f[i] = F.f[j];
                F.f[j] = temp;
            }
        }
    }
}

// spezielle Ausgabefunktion

void show (int zahl, Feld<char*>& Fpc, Feld<int>& Fi, Feld<double>& Fd)
{
    for (int i = 0; i < zahl; i++)
        cout << Fi.f[i] << "\t" << Fd.f[i] << "\t" << Fpc.f[i] << "\n";
}

 
int main ()
{
    int zahl;

    cout << "Feldgre:       ";
    cin >> zahl;

    // "Felder" definieren:

    Feld <char*> Fpc (zahl);            // string
    Feld <int> Fi (zahl);               // ints
    Feld <double> Fd (zahl);            // doubles

    for (int i = 0; i < zahl; i++)
    {
        Fpc.f[i] = new char[80];        // Speicherplatz fr String

        cout << "String:          ";
        cin >> Fpc.f[i];
        cout << "Ganze Zahl:      ";
        cin >> Fi.f[i];
        cout << "Gleitkommazahl:  ";
        cin >> Fd.f[i];
    }

    cout << "\nUnsortiert:\n";

    show (zahl, Fpc, Fi, Fd);

    // sortieren

    sort (Fpc);
    sort (Fi);
    sort (Fd);

    cout << "\nSortiert:\n";

    show (zahl, Fpc, Fi, Fd);
}
