
// Demo-Programm: Initialisierung einer Basisklasse aus dem Konstruktor
//                der abgeleiteten Klassen

#include <iostream.h>
#include <string.h>

class Dokument
{
public:
    Dokument() { anzahl++; }                    // Default-Konstruktor

    Dokument(const char *s1, const char *s2, int i)
                                                // Standard-Konstruktor
    {
        strncpy (_s1, s1, sizeof (_s1) - 1);
        _s1 [sizeof (_s1) - 1] = 0;

        strncpy (_s2, s2, sizeof (_s2) - 1);
        _s2 [sizeof (_s2) - 1] = 0;

        _i = i;

        anzahl++;
    }

    virtual ~Dokument() { anzahl--; }                // Destruktor

    virtual void zeige() { }

    static int anzahl;          // Anzahl der definierten Objekte

protected:
    char _s1[50], _s2[30];
    int _i;
};

int Dokument::anzahl = 0;       // Definiere anzahl
 
class Buch : public Dokument
{
public:
    Buch (const char *Titel, const char *Autor, int Seiten) : 
        Dokument (Titel, Autor, Seiten) { }

    void zeige ()
    {
        cout << "Autor:  " << _s2 << ", Titel: " << _s1 << "\n\t" << _i 
            << " Seiten\n";
    }
};

class Manual : public Dokument
{
public:
    Manual (const char *Titel, int Seiten) : Dokument (Titel, "",
        Seiten)  { }

    void zeige ()
    {
        cout << "Manual: " << _s1 << " - " << _i << " Seiten\n";
    }
};

class Datei : public Dokument
{
public:
    Datei (const char *Inhalt, const char *Pfad, int Bytes) : 
        Dokument (Inhalt, Pfad, Bytes) { }

    void zeige ()
    {
        cout << "Datei:  " << _s1 << ", Pfad: " << _s2 << "\n\t" << _i 
            << " Bytes\n";
    }
};

const int max_Eintr = 6;

Dokument *doc[max_Eintr];               // Feld von Zeigern

int main ()
{
    doc[0] = new Buch ("The C++ Programming Language",
        "Bjarne Stroustrup", 669);
    doc[1] = new Buch ("C - The Complete Reference", 
        "Herbert Schildt", 773);
    doc[2] = new Manual ("Microsoft Visual C++ - C++ Language "
        "Reference", 468);
    doc[3] = new Manual ("Microsoft Quick C Run Time Library Reference",
        687);
    doc[4] = new Datei ("GNU C++ Compiler-Dokumentation",
        "c:\\gnu\\docs\\gcc\\gcc.tex", 173664);
            // ACHTUNG: zwei "\" sind notwendig, um einen "\"
            // darzustellen!
    doc[5] = new Datei ("GNU C Run Time Library Reference",
        "c:\\gnu\\docs\\djgpp\\libcref.i", 226882);

    cout << Dokument::anzahl << " Eintragungen:\n";

    for (int i = 0; i < Dokument::anzahl; i++)
        doc[i]->zeige();                // Liste ausschreiben
}
