
// Demo-Programm: Benutzerdefinierte Inkrement- und Dekrement-Operatoren
//                Version 2: Globale Funktionen als friend

#include <iostream.h>

class Punkt
{
public:
    // Deklaration der Prfix-Operatoren

    friend Punkt& operator++(Punkt&);
    friend Punkt& operator--(Punkt&);   

    //  Deklaration der Postfix-Operatoren

    friend Punkt operator++(Punkt&, int);
    friend Punkt operator--(Punkt&, int);

    // (Default-) Konstruktor

    Punkt (const short& x = 0, const short& y = 0)
        { _x = x; _y = y; }

    // Zugriff

    Zeige(char *s)
        { cout << s << ": x = " << _x << ", y = " << _y << "\n"; }

private:
    short _x, _y;
};

 
// Definition der Inkrement-Operatoren

Punkt& operator++(Punkt& p)     // Prfix
{
    p._x++;                     // Standard-Inkrement
    p._y++;
    return p;
}

Punkt operator++(Punkt& p, int) // Postfix
{
    Punkt temp = p;             // temporre Kopie
    ++p;                        // ruft operator++() auf
    return temp;
}

// Definition der Dekrement-Operatoren

Punkt& operator--(Punkt& p)     // Prfix       
{
    p._x--;                     // Standard-Dekrement
    p._y--;
    return p;
}

Punkt operator--(Punkt& p, int) // Postfix
{
    Punkt temp = p;             // temporre Kopie
    --p;                        // ruft operator--() auf
    return temp;
}

int main ()
{
    Punkt p1 (3, 5);

    p1.Zeige("p1");
    ++p1;                       // Prfix-Inkrement
    p1.Zeige("p1");

    Punkt p2 = p1++;            // Postfix-Inkrement

    p1.Zeige("p1");
    p2.Zeige("p2");

    --p1;                       // Prfix-Dekrement
    p1.Zeige("p1");
    p2 = p1--;                  // Postfix-Dekrement

    p1.Zeige("p1");
    p2.Zeige("p2");
}
