
// Demo-Programm: Speicherverwaltung mit "Buchfhrung"

 
#include <iostream.h>
#include <stdlib.h>             // fr size_t
#include <malloc.h>

int _fLog = 0;                  // Flag: "Buchfhrung" ein/aus
int BAll = 0;                   // Zahl der allokierten Speicherblcke

// global definierter operator new

void *operator new (size_t n)
{
    static int in_new = 0;      // Schutz-Flag

    if (_fLog && ! in_new)
    {
        in_new = 1;             // verhindere rekursive Zugriffe

        cout << "Speicherblock " << ++BAll << " mit " << n << 
            " Bytes allokiert\n";

        in_new = 0;
    }

    return malloc (n);
}

// global definierter operator delete

void operator delete (void *pMem)
{
    static int in_del = 0;      // Schutz-Flag

    if (_fLog && ! in_del)
    {
        in_del = 1;             // verhindere rekursive Zugriffe

        cout << "Speicherblock deallokiert; noch " << --BAll << 
            " Blcke\n";

        in_del = 0;
    }

    free (pMem);
}
 
int main ()
{
    char *Blocks[5];

    _fLog = 1;                  // Buchfhrung einschalten

    for (int i = 0; i < 5; i++)
        Blocks[i] = new char[100];

    for (i = 0; i < 5; i++)
        delete Blocks[i];
}
