
// Demo-Programm: Ein-/Ausgabe mit ungepufferten Standard-C-Funktionen

#include <stdio.h>
#include <string.h>
#include <osfcn.h>              // fr ungepufferten I/O
#include <fcntl.h>              // fr ungepufferten I/O
#include <sys/stat.h>           // fr ungepufferten I/O

class tellist
{
public:
    static int zahl;                    // Zahl der Eintragungen

    tellist ()                          // Default-Konstruktor
        { *_name = 0; *_nummer = 0; }

    tellist (char *Name, char *Nummer)
    {
        strncpy (_name, Name, 40);
        _name[39] = 0;

        strncpy (_nummer, Nummer, 20);
        _nummer[19] = 0;
    }

    void disp ()
        { printf ("Name: %-40s: Nummer: %-20s\n", _name, _nummer); }

private:
    char _name[40], _nummer[20];
};


// Funktionen fr die ungepufferte Ein-/Ausgabe

void lesen (tellist *liste, int max_zahl)
{
    int fd;                             // File Descriptor
    int bytes_rd = 0;                   // Anzahl der gelesenen Bytes

    if ((fd = open ("TELLIST.DAT", O_RDONLY | O_BINARY)) > 0)
        // erfolgreich geffnet
    {
        bytes_rd = read (fd, liste, max_zahl * sizeof(tellist));

        close (fd);
    }

    tellist::zahl = bytes_rd / sizeof (tellist);

    printf ("%i Eintragungen gelesen.\n", tellist::zahl);
}

void schreiben (tellist *liste)
{
    int fd;                             // File Descriptor
    int bytes_wr = 0;                   // geschriebene Bytes

    if ((fd = open ("TELLIST.DAT", O_WRONLY | O_CREAT | O_BINARY, S_IREAD
        | S_IWRITE)) > 0)
            // erfolgreich geffnet
    {
        bytes_wr = write (fd, liste, tellist::zahl * sizeof(tellist));

        close (fd);
    }

    printf ("%i Eintragungen geschrieben.\n", bytes_wr /
        sizeof (tellist));
}

int tellist::zahl = 0;                  // statisches Element

const int max_zahl = 20;                // maximale Zahl der Eintrge

tellist liste[max_zahl];

int main ()
{
    lesen (liste, max_zahl);            // Liste einlesen

    for (int i = 0; i < tellist::zahl; i++)
        liste[i].disp();                // Liste ausschreiben

    printf ("\nNeue Eintragungen eingeben; Ende mit leerem "
        "Namensfeld:\n");

    while (tellist::zahl < max_zahl)
    {
        char buffer1[128], buffer2[128];

        printf ("Name:    ");
        gets (buffer1);

        if (! *buffer1)                 // leerer String
            break;

        printf ("Nummer:  ");
        gets (buffer2);
        
        if (! *buffer2)                 // leerer String
            break;

        liste[tellist::zahl++] = tellist (buffer1, buffer2);
    }

    for (i = 0; i < tellist::zahl; i++)
        liste[i].disp();                // Liste ausschreiben

    schreiben (liste);                  // Liste in Datei schreiben
}
