
// Demo-Programm: Abspeichern von Klassen-Objekten in einer Datei
//                Variante 2: Verwendung eines Enumerators zum
//                Abspeichern der Objekt-Type

#include <iostream.h>
#include <iomanip.h>
#include <strstrea.h>
#include <stdio.h>
#include <string.h>

// Aufzhlungs-Type zur Charakterisierung des Objekts

enum dtype { dokument, buch, manual, datei };

class Dokument
{
public:
    Dokument()                  // Default-Konstruktor
    {
        anzahl++;
        _dt = dokument;
    }

    virtual ~Dokument() { anzahl--; }   // Destruktor

    virtual void zeige() { }

    static int anzahl;          // Anzahl der definierten Objekte

protected:
    void getval ()
    {
        char buf[80];
   
        cin.getline (buf, 80);

        istrstream str (buf);   // Stream-Konstruktor
        str >> _i;              // Wert einlesen
    }
 
    char _s1[40], _s2[20];
    int _i;


    dtype _dt;

    friend void lesen (Dokument **, int);
};

int Dokument::anzahl = 0;       // Definiere anzahl
 
class Buch : public Dokument
{
public:
    Buch ()                     // Default-Konstruktor
    {
        cout << "Buch-Autor:  ";
        cin.getline (_s2, 20);

        cout << "Buch-Titel:  ";
        cin.getline (_s1, 40);

        cout << "Buch-Seiten: ";
        getval ();

        _dt = buch;             // Daten-Type
    }

    Buch (Dokument &d)          // alternativer Konstruktor
    {
        strcpy (_s1, d._s1);
        strcpy (_s2, d._s2);
        _i = d._i;

        _dt = buch;
    }

    void zeige ()
    {
        cout << setiosflags (ios::left) << "Autor:  " << setw (20) 
            << _s2 << " Titel: " << setw (40) << _s1 << "\n\t" << _i 
            << " Seiten\n";
    }
};

class Manual : public Dokument
{
public:
    Manual ()                   // Default-Konstruktor
    {
        cout << "Manual-Titel:  ";
        cin.getline (_s1, 40);

        cout << "Manual-Seiten: ";
        getval ();

        _dt = manual;           // Daten-Type
    }

    Manual (Dokument &d)        // alternativer Konstruktor
    {
        strcpy (_s1, d._s1);
        _i = d._i;

        _dt = manual;
    }

    void zeige ()
    {
        cout << setiosflags (ios::left) << "Manual: " << setw (40) 
            << _s1 << " - " << _i << " Seiten\n";
    }
};

class Datei : public Dokument
{
public:
    Datei ()                    // Default-Konstruktor
    {
        cout << "Datei-Inhalt: ";
        cin.getline (_s1, 40);

        cout << "Datei-Pfad:   ";
        cin.getline (_s2, 20);

        cout << "Datei-Bytes:  ";
        getval ();

        _dt = datei;            // Daten-Type
    }

    Datei (Dokument &d) // alternativer Konstruktor
    {
        strcpy (_s1, d._s1);
        strcpy (_s2, d._s2);
        _i = d._i;

        _dt = datei;
    }

    void zeige ()
    {
        cout << setiosflags (ios::left) << "Datei:  " << setw (40) 
            << _s1 << " Pfad: " << setw (20) << _s2 << "\n\t"
            << _i << " Bytes\n";
    }
};

// Definition der Funktionen fr die Datei-Ein-/Ausgabe

void lesen (Dokument **ppD, int max_zahl)
{
    FILE *file;                 // File Pointer
    int i = 0;
    Dokument Temp;              // Hilfs-Objekt

    if (file = fopen ("LITLIST1.DAT", "rb"))
    {                                           // erfolgreich geffnet
        for ( ; i < max_zahl; i++)
        {
            if (! fread (&Temp, sizeof(Dokument), 1, file))
                break;                          // am Ende der Datei

            // verzweige je nach Datentype

            switch (Temp._dt)
            {
                case dokument:
                    cout << "Falsche Objekt-Type!\n";   
                    i--;        // kein Feldelement definiert
                    break;

                case buch:
                    ppD[i] = new Buch (Temp);
                    break;

                case manual:
                    ppD[i] = new Manual (Temp);
                    break;

                case datei:
                    ppD[i] = new Datei (Temp);
                    break;
            }
        }

        fclose (file);
    }

    cout << i << " Eintragungen gelesen.\n";
}

void schreiben (Dokument **ppD)
{
    FILE *file;                 // File Pointer
    int i = 0;

    if (file = fopen ("LITLIST1.DAT", "wb"))    // erfolgreich geffnet
    {
        for ( ; i < Dokument::anzahl; i++)
            if (! fwrite (ppD[i], sizeof(Dokument), 1, file))
                // Fehler beim Schreiben
                    break;

        fclose (file);
    }

    cout << i << " Eintragungen geschrieben.\n";
}

const int max_Eintr = 20;

Dokument *doc[max_Eintr];               // Feld von Zeigern

int main ()
{
    lesen (doc, max_Eintr);             // Liste einlesen

    cout << Dokument::anzahl << " Eintragungen:\n";

    for (int i = 0; i < Dokument::anzahl; i++)
        doc[i]->zeige();                // Liste ausschreiben

    cout << Dokument::anzahl << " Eintragungen.\n";

    while (Dokument::anzahl < max_Eintr)
    {
        char buf[10];

        if (! cin)                      // Eingabe-Fehler
        {
            cout << "\nFehlerhafte Eingabe!\n";
            cin.clear();                // Fehler-Flags lschen
        }

        cout << "'B'uch, 'M'anual, 'D'atei, oder 'E'nde ?  ";

        cin.getline (buf, 10);          // Schaltzeichen einlesen
 
        switch (*buf)
        {
            case 'B':
            case 'b':
                doc[Dokument::anzahl - 1] = new Buch;
                break;

            case 'M':
            case 'm':
                doc[Dokument::anzahl - 1] = new Manual;
                break;

            case 'D':
            case 'd':
                doc[Dokument::anzahl - 1] = new Datei;
                break;

            case 'E':
            case 'e':
                goto weiter;

            default:
                cout << "\nFalscher Befehl!\n";
        }
    }

    weiter:                     // Einsprung bei Programm-Abbruch

    for (i = 0; i < Dokument::anzahl; i++)
        doc[i]->zeige();        // Liste ausschreiben

    cout << Dokument::anzahl << " Eintragungen.\n";

    schreiben (doc);            // Liste in Datei schreiben
}
